using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using TMPro;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.UI;
using System.Reflection;

namespace Test
{
    public class Test
    {
        public static void Main()
        {
            		CategoryBuilder.Create("Attack On People Playground", "pp", ModAPI.LoadSprite("icon.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Eren Yeager",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "If you win, you live. If you lose, you die. If you don't fight, you can't win",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("erenattack.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("eren.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                        head.gameObject.AddComponent<ErenTransform2>();
                        upper.gameObject.AddComponent<FoundingTransform2>();

                        head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                          {;
                             UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                             UnityEngine.Object effect = (UnityEngine.Object)null;
                             foreach(UnityEngine.Object prefab in prefabs)
                          {
                            if(prefab.name == "EnormousExplosion")
                          {
                            effect = prefab;
                            break;
                          }
                          }
                            GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                          };

                          upper.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                            {;
                               UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                               UnityEngine.Object effect = (UnityEngine.Object)null;
                               foreach(UnityEngine.Object prefab in prefabs)
                            {
                              if(prefab.name == "EnormousExplosion")
                            {
                              effect = prefab;
                              break;
                            }
                            }
                              GameObject.Instantiate(effect, upper.transform.position, Quaternion.identity);
                            };

                          foreach (var Limbs in person.Limbs)
                          {

                          UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                            useEventTrigger.Event = new UnityEvent();
                            useEventTrigger.Event.AddListener(delegate ()
                            {
                              Limbs.gameObject.layer = 10;
                            });
                          }

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Armin Alert",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "To endure becoming a monster you have to discard your humanity",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("arminn.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("armin.png");
                        var flesh = ModAPI.LoadTexture("Default Flesh.png");
                        var bone = ModAPI.LoadTexture("Default Skeleton.png");

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<ColossalTransform2>();

                        head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                          {;
                             UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                             UnityEngine.Object effect = (UnityEngine.Object)null;
                             foreach(UnityEngine.Object prefab in prefabs)
                          {
                            if(prefab.name == "EnormousExplosion")
                          {
                            effect = prefab;
                            break;
                          }
                          }
                            GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                          };

                          foreach (var Limbs in person.Limbs)
                          {

                          UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                            useEventTrigger.Event = new UnityEvent();
                            useEventTrigger.Event.AddListener(delegate ()
                            {
                              Limbs.gameObject.layer = 10;
                            });
                          }

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mikasa Ackerman",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "This world is cruel. It is also very beautiful",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("mikasa1.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("mikasa 1.png");
                        var flesh = ModAPI.LoadTexture("Default Flesh.png");
                        var bone = ModAPI.LoadTexture("Default Skeleton.png");


                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sasha Brause",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "It's Alright If You're Weak, There Are People Who Will Come And Rescue You",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("sass.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("sasha-aka-MYWIFE!!!.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<CartTransform>();

                        var brea = new GameObject("brea");
                        brea.transform.SetParent(Instance.transform.Find("Head"));
                        brea.transform.localPosition = new Vector3(0f, 0f);
                        brea.transform.localScale = new Vector3(1f, 1f);
                        var breaSprite = brea.AddComponent<SpriteRenderer>();
                        breaSprite.sprite = ModAPI.LoadSprite("pony.png");
                        brea.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Levi Ackerman",
                    NameToOrderByOverride = "Human 2",
                    DescriptionOverride = "I can believe in my own abilities or the choices of the companions I trust. But no one ever knows how it will turn out. So choose for yourself, whichever decision you will regret the least",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("23.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("levi.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Sasha (Season 3)",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "Meat...",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("saas3.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("sasha SEASON 3.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<CartTransform>();

                        var brea = new GameObject("brea");
                        brea.transform.SetParent(Instance.transform.Find("Head"));
                        brea.transform.localPosition = new Vector3(0f, 0f);
                        brea.transform.localScale = new Vector3(1f, 1f);
                        var breaSprite = brea.AddComponent<SpriteRenderer>();
                        breaSprite.sprite = ModAPI.LoadSprite("pony.png");
                        brea.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mikasa Ackerman (Season 4)",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "If I can't, then I'll just die. But if I win I live. Unless I fight, I cannot win",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("mikasa4.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("mikasa season 4.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");


                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Armored Titan",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "Gabi!",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("armored.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pixil-frame-0_8.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var head = Instance.transform.Find("Head");

                        head.gameObject.AddComponent<ArmoredTransform>();

                        foreach (var Limbs in person.Limbs)
                          {
                            Limbs.InitialHealth *= 100;
                            Limbs.Health *= 100;
                            Limbs.BreakingThreshold *= 1000;
                            Limbs.transform.root.localScale *= 1.17f;
                            Limbs.IsAndroid = true;
                            Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                            Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.001f;
                            Limbs.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                          }


                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Attack Titan",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "AAAAARRRRRRGGHH",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("ata.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pixil-frame-0 (10).png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");

                        head.gameObject.AddComponent<ErenTransform>();

                        foreach (var Limbs in person.Limbs)
                          {
                            Limbs.InitialHealth *= 100;
                            Limbs.Health *= 100;
                            Limbs.BreakingThreshold *= 1000;
                            Limbs.transform.root.localScale *= 1.17f;
                            Limbs.IsAndroid = true;
                            Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                            Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.001f;
                          }

                        person.SetBodyTextures(skin, flesh, bone, 1);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Warhammer Titan",
                    NameToOrderByOverride = "Human",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                    ThumbnailOverride = ModAPI.LoadSprite("warham.png"),
                    AfterSpawn = (Instance) =>
                    {
                      var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("pixil-frame-0_11.png");
                        var flesh = ModAPI.LoadTexture("flesh layer.png");
                        var bone = ModAPI.LoadTexture("bone layer.png");

                        foreach (var Limbs in person.Limbs)
                          {
                            Limbs.InitialHealth *= 100;
                            Limbs.Health *= 100;
                            Limbs.BreakingThreshold *= 1000;
                            Limbs.transform.root.localScale *= 1.17f;
                            Limbs.IsAndroid = true;
                            Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                            Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.001f;
                          }


                        person.SetBodyTextures(skin, flesh, bone, 2);
                    }
                }
            );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Beast Titan",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "Monky",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("beas.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("beast.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      foreach (var Limbs in person.Limbs)
                        {
                          Limbs.InitialHealth *= 100;
                          Limbs.Health *= 100;
                          Limbs.BreakingThreshold *= 1000;
                          Limbs.transform.root.localScale *= 1.18f;
                          Limbs.IsAndroid = true;
                          Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                          Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.001f;
                        }

                        var legFront = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var legFront2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var legBack2 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var legBack = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var body1 = Instance.transform.Find("Body").Find("MiddleBody");
                        var body2 = Instance.transform.Find("Body").Find("UpperBody");
                        var body3 = Instance.transform.Find("Body").Find("LowerBody");
                        var armFront1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var armFront2 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var armBack1 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var armBack2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var footFront = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var footBack = Instance.transform.Find("BackLeg").Find("Foot");

                        legFront2.transform.localScale = new Vector3(0.7f, 1f);
                        legBack.transform.localScale = new Vector3(0.7f, 1f);
                        body1.transform.localScale = new Vector3(1.2f, 1f);
                        body2.transform.localScale = new Vector3(1.2f, 1f);
                        body3.transform.localScale = new Vector3(1.2f, 1f);
                        armFront1.transform.localScale = new Vector3(1f, 1.3f);
                        armFront2.transform.localScale = new Vector3(1f, 1.3f);
                        armBack1.transform.localScale = new Vector3(1f, 1.3f);
                        armBack2.transform.localScale = new Vector3(1f, 1.3f);
                        head.transform.localScale = new Vector3(0.7f, 0.7f);

                        armFront1.localPosition = new Vector3(0f, -0.2f, 0f); //pierwszy numerek to odległość, drugi wysokość a trzeci kąt przechylenia
                        armFront2.localPosition = new Vector3(0f, -0.7f, 0f);
                        armBack1.localPosition = new Vector3(0f, -0.2f, 0f); //0.06f odległość, -0.447f wysokość -0.26f, -0.8f, 0f
                        armBack2.localPosition = new Vector3(0f, -0.7f, 0f); //0.06f, -0.8f, 0f
                        head.localPosition = new Vector3(0f, 0.7f, 0f);

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Colossal Titan",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "*steam go boom*",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("colossla.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("titan.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<ColossalTransform>();

                      head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                        {;
                           UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                           UnityEngine.Object effect = (UnityEngine.Object)null;
                           foreach(UnityEngine.Object prefab in prefabs)
                        {
                          if(prefab.name == "EnormousExplosion")
                        {
                          effect = prefab;
                          break;
                        }
                        }
                          GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                        };

                      foreach (var Limbs in person.Limbs)
                        {
                          Limbs.InitialHealth *= 10000;
                          Limbs.Health *= 10000;
                          Limbs.BreakingThreshold *= 10000;
                          Limbs.transform.root.localScale *= 1.28f;
                          Limbs.IsAndroid = true;
                          Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.0001f;
                          Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0001f;
                        }


                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Cart Titan",
                  NameToOrderByOverride = "humans",
                  DescriptionOverride = "pieck my beloved",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("cart.png"),
                  AfterSpawn = (Instance) =>
                  {

                      var person = Instance.GetComponent<PersonBehaviour>();

                      var skin = ModAPI.LoadTexture("cart titan.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<CartTransform>();

                        var brea = new GameObject("brea");
                        brea.transform.SetParent(Instance.transform.Find("Head"));
                        brea.transform.localPosition = new Vector3(0f, 0f);
                        brea.transform.localScale = new Vector3(1f, 1f);
                        var breaSprite = brea.AddComponent<SpriteRenderer>();
                        breaSprite.sprite = ModAPI.LoadSprite("cart mouth.png");
                        brea.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var legFront = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var legFront2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var legBack = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var legBack2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var body1 = Instance.transform.Find("Body").Find("MiddleBody");
                        var body2 = Instance.transform.Find("Body").Find("UpperBody");
                        var body3 = Instance.transform.Find("Body").Find("LowerBody");
                        var armFront1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var armFront2 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var armBack1 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var armBack2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var footFront = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var footBack = Instance.transform.Find("BackLeg").Find("Foot");

                      foreach (var limb in person.Limbs)
                        {
                        limb.InitialHealth *= 10000;
                        limb.Health *= 10000;
                        limb.BreakingThreshold *= 10000;
                        limb.transform.root.localScale *= 1.18f;
                        limb.IsAndroid = true;
                        limb.GetComponent<PhysicalBehaviour>().InitialMass = 0.0001f;
                        limb.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0001f;
                        }
                      }
                  }
              );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Founding Titan",
                  NameToOrderByOverride = "humans",
                  DescriptionOverride = "BEWARE!",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("founding titar34.png"),
                  AfterSpawn = (Instance) =>
                  {

                      var person = Instance.GetComponent<PersonBehaviour>();

                      var body1 = Instance.transform.Find("Body").Find("MiddleBody");
                      var body2 = Instance.transform.Find("Body").Find("UpperBody");
                      var body3 = Instance.transform.Find("Body").Find("LowerBody");

                      var skin = ModAPI.LoadTexture("pixil-frame-0 (11).png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");
                      person.SetBodyTextures(skin, flesh, bone, 3);

                        var upper = new GameObject("upper");
                        upper.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        upper.transform.localPosition = new Vector3(0f, 0f);
                        upper.transform.localScale = new Vector3(1f, 1f);
                        var upperSprite = upper.AddComponent<SpriteRenderer>();
                        upperSprite.sprite = ModAPI.LoadSprite("pixil-frame-0 (14).png");
                        upper.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var middle = new GameObject("middle");
                        middle.transform.SetParent(Instance.transform.Find("Body").Find("MiddleBody"));
                        middle.transform.localPosition = new Vector3(0f, 0f);
                        middle.transform.localScale = new Vector3(1f, 1f);
                        var middleSprite = middle.AddComponent<SpriteRenderer>();
                        middleSprite.sprite = ModAPI.LoadSprite("pixil-frame-0 (13).png");
                        middle.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var lower = new GameObject("lower");
                        lower.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        lower.transform.localPosition = new Vector3(0f, 0f);
                        lower.transform.localScale = new Vector3(1f, 1f);
                        var lowerSprite = lower.AddComponent<SpriteRenderer>();
                        lowerSprite.sprite = ModAPI.LoadSprite("pixil-frame-0 (12).png");
                        lower.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        body1.transform.localScale = new Vector3(1.6f, 1f);
                        body2.transform.localScale = new Vector3(1.5f, 1f);
                        body3.transform.localScale = new Vector3(1.6f, 1f);

                        foreach (var body in person.Limbs)
                        {
                           body.Health *= 10000000f;
                           body.BreakingThreshold *= 100000f;
                           body.transform.root.localScale *= 1.53f;
                           body.IsAndroid = true;
                           body.GetComponent<PhysicalBehaviour>().InitialMass = 0.000001f;
                           body.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.000001f;
                      }
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Female Titan",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "Annie boobs!?",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("fem.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("woman.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");
                      var upper = Instance.transform.Find("Body").Find("UpperBody");

                      head.gameObject.AddComponent<FemaleTransform>();

                      foreach (var Limbs in person.Limbs)
                        {
                          Limbs.InitialHealth *= 100;
                          Limbs.Health *= 100;
                          Limbs.BreakingThreshold *= 1000;
                          Limbs.transform.root.localScale *= 1.15f;
                          Limbs.IsAndroid = true;
                          Limbs.GetComponent<PhysicalBehaviour>().InitialMass = 0.001f;
                          Limbs.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.001f;
                        }

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Annie Leonhart",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "What's lost isn't coming back!",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("annime are you ok.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("annie.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<FemaleTransform2>();

                      head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                        {;
                           UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                           UnityEngine.Object effect = (UnityEngine.Object)null;
                           foreach(UnityEngine.Object prefab in prefabs)
                        {
                          if(prefab.name == "EnormousExplosion")
                        {
                          effect = prefab;
                          break;
                        }
                        }
                          GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                        };

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Pieck Finger",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "Ohayo Porco",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("pieckac.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("pieck.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<CartTransform2>();

                      head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                        {;
                           UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                           UnityEngine.Object effect = (UnityEngine.Object)null;
                           foreach(UnityEngine.Object prefab in prefabs)
                        {
                          if(prefab.name == "EnormousExplosion")
                        {
                          effect = prefab;
                          break;
                        }
                        }
                          GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                        };

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Reiner Braun",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "Do You Think This World Has A Future?",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("artgrtr.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();
                      var skin = ModAPI.LoadTexture("reiner.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<ArmoredTransform2>();

                      head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                        {;
                           UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                           UnityEngine.Object effect = (UnityEngine.Object)null;
                           foreach(UnityEngine.Object prefab in prefabs)
                        {
                          if(prefab.name == "EnormousExplosion")
                        {
                          effect = prefab;
                          break;
                        }
                        }
                          GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                        };

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Porco Galliard",
                  NameToOrderByOverride = "Human",
                  DescriptionOverride = "gaaa",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("nom2.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var person = Instance.GetComponent<PersonBehaviour>();

                      var skin = ModAPI.LoadTexture("porco.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<JawTransform2>();

                      head.gameObject.AddComponent<UseEventTrigger>().Action = () =>
                        {;
                           UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                           UnityEngine.Object effect = (UnityEngine.Object)null;
                           foreach(UnityEngine.Object prefab in prefabs)
                        {
                          if(prefab.name == "EnormousExplosion")
                        {
                          effect = prefab;
                          break;
                        }
                        }
                          GameObject.Instantiate(effect, head.transform.position, Quaternion.identity);
                        };

                          {;
                             UnityEngine.Object[] prefabs = Resources.FindObjectsOfTypeAll(typeof(GameObject));
                             UnityEngine.Object effect = (UnityEngine.Object)null;
                             foreach(UnityEngine.Object prefab in prefabs)
                          {
                            if(prefab.name == "EnormousExplosion")
                          {
                            effect = prefab;
                            break;
                          }
                          }
                          };

                        foreach (var Limbs in person.Limbs)
                        {

                        UseEventTrigger useEventTrigger = head.gameObject.AddComponent<UseEventTrigger>();
                          useEventTrigger.Event = new UnityEvent();
                          useEventTrigger.Event.AddListener(delegate ()
                          {
                            Limbs.gameObject.layer = 10;
                          });
                        }

                      person.SetBodyTextures(skin, flesh, bone, 1);
                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Jaw Titan",
                  NameToOrderByOverride = "humans",
                  DescriptionOverride = "gaaa big jaw titan",
                  CategoryOverride = ModAPI.FindCategory("Attack On People Playground"),
                  ThumbnailOverride = ModAPI.LoadSprite("nomnomnom.png"),
                  AfterSpawn = (Instance) =>
                  {

                      var person = Instance.GetComponent<PersonBehaviour>();

                      var skin = ModAPI.LoadTexture("pixil-frame-0_2.png");
                      var flesh = ModAPI.LoadTexture("flesh layer.png");
                      var bone = ModAPI.LoadTexture("bone layer.png");
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      var head = Instance.transform.Find("Head");

                      head.gameObject.AddComponent<JawTransform>();

                      foreach (var limb in person.Limbs)
                        {
                        limb.InitialHealth *= 10000;
                        limb.Health *= 10000;
                        limb.BreakingThreshold *= 10000;
                        limb.transform.root.localScale *= 1.19f;
                        limb.IsAndroid = true;
                        limb.GetComponent<PhysicalBehaviour>().InitialMass = 0.0001f;
                        limb.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0001f;
                        }
                      }
                  }
              );
        }
    }
}
